
// GameBoy  (c)bn
// http://cbn.narod.ru  e-mail:cbn@yandex.ru

#define UNPACK //  
#include "..\swilib.h"
#include "zfont.h"

#define byte signed char
#define false 0
#define null 0
#define true 1
#define boolean char

char Title[]="GameBoy (c)bn";
void UpdateCSMname();

char filename[128], *file;
int mode=0;
unsigned int err;
int loadfilesize=0;

const int screensize=132*176;
unsigned char screen[132*176];

char menu[128];
char help[]=
" GameBoy elf"
"\n1.Load 0-9,#"
"\n2.Save 0-9,#"
"\n3.FrmSkip 0-4:%d"
"\n4.BkColor 0-4:%d"
"\n8.Resize"
"\ncbn.narod.ru"
"\ncbn@yandex.ru";

signed char skipping=99;
unsigned char frameskip=1, fsmall=0, rotate=0, splitcolor=0;

void drawsym(char *out, char c){ //    
  int i,j;
  byte b, *bptr=(byte*)zfont+((c-=0x20)<=0?0:(c<<3));
  for(j=0;j<8;j++){
    b=*bptr++;
    for(i=0;i<8;i++){
      *out++=(b&0x80)?0xff:0; //colors
      b<<=1;
    }
    out+=132-8;
  }
}

void drawhelp(){
  int i=0,x=0,y=0;
  sprintf(menu,help,frameskip,splitcolor);
  while(menu[i]){
    if(menu[i]=='\n' || x>=132/8){ x=0; ++y;}
    if(y>=176/10) break;
    drawsym((char*)screen+y*132*10+x*8+4,menu[i]);
    ++x;
    ++i;
  }
}

    char *loadfile(char *filename); //  , -
    void addressWriteRom(int i, int j);
    void performHdma();
    byte ioRead(int i);
    void ioWrite(int i, short word0) ;    
    void notifyScanline(int i) ;
    void draw(int i, int j) ;
    void CPUreset() ;
    void dibuja(int di, int dj, int dk, int dl) ;

struct Paleta {
    short data[4];
    int gbcData[4];
    unsigned char colours[4]; // = { -1, 0xffaaaaaa, 0xff555555, 0xff000000 };  !!!
};

void PaletaInit(struct Paleta *p){
   p->colours[0]=0xff;//-1;
   p->colours[1]=0x92;//ffaaaaaa;
   p->colours[2]=0x49;//0xff555555;
   p->colours[3]=0;//0xff000000;
}

  void PaletaGameBoy(struct Paleta *p, int i, int j, int k, int l) {
        p->data[0] = (short)i;
        p->data[1] = (short)j;
        p->data[2] = (short)k;
        p->data[3] = (short)l;
    }

  void decodePalette(struct Paleta *p, int i) {
        p->data[0] = (short)(i & 3);
        p->data[1] = (short)((i & 0xc) >> 2);
        p->data[2] = (short)((i & 0x30) >> 4);
        p->data[3] = (short)((i & 0xc0) >> 6);
    }

    void PaletaGameBoy1(struct Paleta *p, int i) {
        decodePalette(p,i);
    }

    void setColours(struct Paleta *p, int i, int j, int k, int l) {
        p->colours[0] = i;
        p->colours[1] = j;
        p->colours[2] = k;
        p->colours[3] = l;
    }

    byte getGbcColours(struct Paleta *p, int i, boolean flag) {
        if(flag)  return (byte)(p->gbcData[i] >> 8);
        else      return (byte)(p->gbcData[i] & 0xff);
    }

    void setGbcColours(struct Paleta *p, int i, boolean flag, int j) {
        int j1; 
        if(flag)  p->gbcData[i] = p->gbcData[i] & 0xff | j << 8;
        else      p->gbcData[i] = p->gbcData[i] & 0xff00 | j;
        int k = (p->gbcData[i] & 0x1f) << 3;
        int l = (p->gbcData[i] & 0x3e0) >> 2;
        int i1 = (p->gbcData[i] & 0x7c00) >> 7;
        p->data[0] = 0;
        p->data[1] = 1;
        p->data[2] = 2;
        p->data[3] = 3;
        j1 = 0xff000000 | (k & 0xff) << 16 | (l & 0xff) << 8 | (i1 & 0xff) << 0;
        p->colours[i] = j1;
    }


    int getRgbEntry(struct Paleta *p, int i) {
        return p->colours[p->data[i]];
    }

    short getEntry(struct Paleta *p, int i) {
        return p->data[i];
    }
////////////end palette
//////// ChipGrafico{// extends Canvas{ //implements Runnable 

int     nextHBlank = 60;
int     nextTimaOverflow = 0x7fffffff;
int     nextInterruptEnable = 0x7fffffff;
int     nextTimedInterrupt = 60;
boolean interruptsArmed=false;

int ancho;
    int alto;
    const int backBufferlength=160*160;
    unsigned char backBuffer[160*160];
    
    int width = 160;
    int height = 160;
//    byte *registers;
//    byte *oam;
//    int ajustar = 1;
//    int mejorar = 1;
    boolean transparencias = false;
    boolean listo = false;
    //int framesDrawn = 0;
    //int frameSkip = 4;
    struct Paleta gbcBackground[8];
    struct Paleta gbcSprite[8];
    boolean spritesEnabled = true;
    boolean bgEnabled = true;
    boolean winEnabled = true;
    boolean bgWindowDataSelect = true;
    boolean doubledSprites = false;
    boolean hiBgTileMapAddress = false;
    const int TILE_BKG = 0;
    const int TILE_OBJ1 = 4;
    const int TILE_OBJ2 = 8;
    const int TILE_FLIPX = 1;
    const int TILE_FLIPY = 2;
    byte videoRam[16384];
    struct Paleta backgroundPalette;// = new PaletaGameBoy(0, 1, 2, 3);
    struct Paleta obj1Palette;// = new PaletaGameBoy(0, 1, 2, 3);
    struct Paleta obj2Palette;// = new PaletaGameBoy(0, 1, 2, 3);
    int tileStart = 0;
    int vidRamStart = 0;
    //boolean frameDone = true;

//    struct Paleta *damebgp() {    return &backgroundPalette;  }
    struct Paleta *damegbcBack() {   return gbcBackground;  }
    struct Paleta *damegbcSprite() {    return gbcSprite;  }

///////////////////end ChipGrafico



   // int vidRamStart = 0;
    //byte videoRam[];
    int veces = 0;
    int a;
    int b;
    int c;
    int d;
    int e;
    int f;
    int sp;
    int pc;
    int hl;
    int instrCount = 0;
    boolean interruptsEnabled = false;
    int ieDelay = -1;
    boolean timaEnabled = false;
    boolean inInterrupt = false;
    int F_ZERO = 128;
    int F_SUBTRACT = 64;
    int F_HALFCARRY = 32;
    int F_CARRY = 16;
    int INSTRS_PER_VBLANK = 9000;
    int instrsPerTima = 6000;
const     int INSTRS_PER_HBLANK = 0x3f;////-1 63
const    int INSTRS_PER_DIV=0xff;////-1 31
const int fakediv=0x7fff;    
 
   int INT_VBLANK = 1;
    int INT_LCDC = 2;
    int INT_TIMA = 4;
    int INT_SER = 8;
    int INT_P10 = 16;
    byte mainRam[32768];
    byte oam[256];
    //ChipGrafico graphicsChip;
    boolean terminate;
    boolean running = false;
    boolean gbcFeatures = true;
    boolean allowGbcFeatures = true;
    int gbcRamBank = 1;
    byte *rom=0; //free!!! 
    byte *saveram=0;
    byte ram[8192];
    int cartType;
    int pageStart = 16384;
    int currentBank = 1;
    int savedBank = -1;
    int ramBank;
    int ramPageStart;
    boolean mbc1LargeRamMode = false;
    boolean ramEnabled;
    boolean disposed = false;
//    String romFileName;
    boolean cartridgeReady = false;
    byte registers[256];
    struct Paleta gbcBackground[8];
    struct Paleta gbcSprite[8];
//    struct Paleta backgroundPalette;
    struct Paleta obj1Palette;
    struct Paleta obj2Palette;
//    CPU dmgcpu;
    boolean padLeft;
    boolean padRight;
    boolean padUp;
    boolean padDown;
    boolean padA;
    boolean padB;
    boolean padStart;
    boolean padSelect;
    boolean hdmaRunning;
    boolean doubleSpeed=false;
	int repaintime=0;
	int delay=500;
//	String romnumber="/1";
//	ReadPlay rp;


    byte addressRead(int i) {
        int j = i & 0xf000;
        if(j <= 28672)
            if(i < 16384) return rom[i];
            else return rom[(pageStart + i) - 16384];
        if(j <= 36864) return videoRam[(i - 32768) + vidRamStart];
        if(j <= 45056) return ram[(i - 40960) + ramPageStart];
        if(j == 53248) return mainRam[(i - 53248) + gbcRamBank * 4096];
        if(j <= 57344) return mainRam[i - j];
        if(j == 61440) {
            if(i < 65024) return mainRam[i - 57344];
            if(i < 65280) return oam[i - 65024];
            else return ioRead(i - 65280);
        } else { return (byte)255;}
    }

    void addressWrite(int i, int j) {
        int k = i & 0xf000;
        if(k <= 28672)
            addressWriteRom(i, j);
        else
        if(k <= 36864)
            videoRam[(i - 32768) + vidRamStart] = (byte)j;
        else
        if(k <= 45056)
            addressWriteRom(i, j);
        else
        if(k == 53248)
            mainRam[(i - 53248) + gbcRamBank * 4096] = (byte)j;
        else
        if(k <= 57344)
            mainRam[i - k] = (byte)j;
        else
        if(k == 61440)
            if(i < 65024)
                mainRam[i - 57344] = (byte)j;
            else
            if(i < 65280)
                oam[i - 65024] = (byte)j;
            else
                ioWrite(i - 65280, (short)j);
    }

    void setBC(int i) {
        b = (short)((i & 0xff00) >> 8);
        c = (short)(i & 0xff);
    }

    void setDE(int i) {
        d = (short)((i & 0xff00) >> 8);
        e = (short)(i & 0xff);
    }

    void setHL(int i) {
        hl = i;
    }

    int registerRead(int i) {
        switch(i) {
        case 0: // '\0'
            return b;

        case 1: // '\001'
            return c;

        case 2: // '\002'
            return d;

        case 3: // '\003'
            return e;

        case 4: // '\004'
            return (short)((hl & 0xff00) >> 8);

        case 5: // '\005'
            return (short)(hl & 0xff);

        case 6: // '\006'
            return (addressRead(hl)&0xff);

        case 7: // '\007'
            return a;
        }
        return -1;
    }

    void registerWrite(int i, int j) {
        switch(i) {
        case 0: // '\0'
            b = (short)j;
            return;

        case 1: // '\001'
            c = (short)j;
            return;

        case 2: // '\002'
            d = (short)j;
            return;

        case 3: // '\003'
            e = (short)j;
            return;

        case 4: // '\004'
            hl = hl & 0xff | j << 8;
            return;

        case 5: // '\005'
            hl = hl & 0xff00 | j;
            return;

        case 6: // '\006'
            addressWrite(hl, j);
            return;

        case 7: // '\007'
            a = (short)j;
            return;
        }
    }

    void checkEnableGbc() {
        if((rom[323] & 0x80) == 128 && allowGbcFeatures)
            gbcFeatures = true;
        else
            gbcFeatures = false;
    }


    void setDoubleSpeedCpu(boolean flag) {
        doubleSpeed=flag;
        /*
        if(flag) {
            INSTRS_PER_HBLANK = BASE_INSTRS_PER_HBLANK * 2;
            INSTRS_PER_DIV = BASE_INSTRS_PER_DIV * 2;
        } else {
            INSTRS_PER_HBLANK = BASE_INSTRS_PER_HBLANK;
            INSTRS_PER_DIV = BASE_INSTRS_PER_DIV;
        }*/
    }

    void checkInterrupts() {
        int i = registers[15];
        byte byte0 = registers[255];
        if((i & byte0) != 0) {
            sp -= 2;
            addressWrite(sp + 1, pc >> 8);
            addressWrite(sp, pc & 0xff);
            interruptsEnabled = false;
            if((i & byte0 & INT_VBLANK) != 0) {
                pc = 64;
                i -= INT_VBLANK;
            } else
            if((i & byte0 & INT_LCDC) != 0) {
                pc = 72;
                i -= INT_LCDC;
            } else
            if((i & byte0 & INT_TIMA) != 0) {
                pc = 80;
                i -= INT_TIMA;
            } else
            if((i & byte0 & INT_SER) != 0) {
                pc = 88;
                i -= INT_SER;
            }
            registers[15] = (byte)i;
            inInterrupt = true;
        }
    }

    //void triggerInterrupt(int i) {  registers[15] |= i; }
/*
    void initiateInterrupts() {
            if(timaEnabled && (instrCount & fakediv) == 0) { //% instrsPerTima
                if(registers[5] == 0) {
                    registers[5] = registers[6];
                    if((registers[255] & INT_TIMA) != 0)
                        registers[15] |=INT_TIMA;
                }
                registers[5]++;
            }else
            if((instrCount & INSTRS_PER_DIV) == 0)
                registers[4]++;
            else
            if((instrCount & INSTRS_PER_HBLANK) == 0) {
                if((registers[255] & INT_LCDC) != 0 && registers[69] == registers[68])
                    registers[15] |=INT_LCDC;
                if(gbcFeatures && hdmaRunning)
                    performHdma();
                if((registers[68]&0xff) == 144) {
                    //if(ChipGrafico.framesDrawn % ChipGrafico.frameSkip == 0) {
                        //for(int i = 144; i < 170; i++)
                            notifyScanline(144,170-144);//???

                    //}
                    if((registers[64] & 0x80) != 0 && (registers[255] & INT_VBLANK) != 0)
                        registers[15] |=INT_VBLANK;
                }
                notifyScanline((registers[68]&0xff),0);
                registers[68] = (byte)((registers[68]&0xff) + 1);
                if((registers[68]&0xff) >= 155) {
                    registers[68] = 0;
                    draw(0,0);
                    repaint();
                    //ChipGrafico.frameDone = false;
                    //graphicsChip.run2();
                }
            }
    }
    
    
    
    
        public final void vBlank() {
        timer += 17;
        if(skipping && g != null) {
            skipCount++;
            if(skipCount >= maxFrameSkip) {
                skipping = false;
                timer = (int)System.currentTimeMillis();
            } else {
                skipping = timer - (int)System.currentTimeMillis() < 0;
            }
            return;
        }
        lastSkipCount = skipCount;
        frameDone = false;
        cpu.screen.repaint();
        while(!frameDone && !cpu.terminate) 
            Thread.yield();
        int now = (int)System.currentTimeMillis();
        if(maxFrameSkip == 0)
            skipping = false;
        else
            skipping = timer - now < 0;
        skipCount = 0;
    }

    
*/
    
    void vBlank() { 
      if(++skipping>frameskip){
        skipping=0;
        draw(0,0); 
        REDRAW();
//        repaint();
      }
    }
    
     void initiateInterrupts() {
        if(instrCount >= nextTimaOverflow) {
            nextTimaOverflow += instrsPerTima * (256 - registers[6]);
            if((registers[255] & 4) != 0) {
                interruptsArmed = true;
                registers[15] |= 4;
            }
            nextTimedInterrupt = nextHBlank >= nextTimaOverflow ? nextTimaOverflow : nextHBlank;
            nextTimedInterrupt = nextInterruptEnable >= nextTimedInterrupt ? nextTimedInterrupt : nextInterruptEnable;
        } else
        if(instrCount >= nextHBlank) {
            nextHBlank += 60;
            registers[68]++;
            int line = registers[68] & 0xff;
            if(line == 154)
                line = registers[68] = 0;
            if(line <= 143) {
                if(skipping>=frameskip)
                  notifyScanline(line);//?
                if(line == 143) {
                    vBlank();
                    if((registers[64] & 0x80) != 0 && (registers[255] & 1) != 0) {
                        interruptsArmed = true;
                        registers[15] |= 1;
                        if((registers[65] & 0x10) != 0 && (registers[255] & 2) != 0)
                            registers[15] |= 2;
                    }
                } else
                if((registers[64] & 0x80) != 0 && (registers[255] & 2) != 0)
                    if((registers[65] & 0x40) != 0 && (registers[69] & 0xff) == line) {
                        interruptsArmed = true;
                        registers[15] |= 2;
                    } else
                    if((registers[65] & 8) != 0) {
                        interruptsArmed = true;
                        registers[15] |= 2;
                    }
            }
            nextTimedInterrupt = nextHBlank >= nextTimaOverflow ? nextTimaOverflow : nextHBlank;
            nextTimedInterrupt = nextInterruptEnable >= nextTimedInterrupt ? nextTimedInterrupt : nextInterruptEnable;
        } else
        if(instrCount >= nextInterruptEnable) {
            interruptsEnabled = true;
            nextInterruptEnable = 0x7fffffff;
            nextTimedInterrupt = nextHBlank >= nextTimaOverflow ? nextTimaOverflow : nextHBlank;
        }
    }


	void execute() {
        //reset();
   // void execute(int i) {
 //System.out.print("execute");////
        terminate = false;
        running = true;
        int i1,i2,l1,k1,word2;
        short word7;
        int j1;
//        byte byte0;
        for(instrCount = 0; !terminate; ++instrCount) {
         //if(instrCount<132*176){
//           graphicsChip.backBuffer[instrCount]=0xff0000;
//      		rp.repaint();
       		//rp.serviceRepaints();
//         }
        	if((pc &= 0xffff) < 0x3ffe){
        	  k1=(i2=rom[pc+1])&0xff;
        	  l1=rom[pc+2]&0xff;
        	  word2 = rom[pc]&0xff;
        	}else{
              k1 = (i2 = addressRead(pc + 1))&0xff;
              l1 = addressRead(pc + 2)&0xff;
              word2 = addressRead(pc)&0xff;
            }
            switch(word2){
            case 0: // '\0'
                pc++;
                break;

            case 1: // '\001'
                pc += 3;
                b = l1;
                c = k1;
                break;

            case 2: // '\002'
                pc++;
                addressWrite(b << 8 | c, a);
                break;

            case 6: // '\006'
                pc += 2;
                b = k1;
                break;

            case 8: // '\b'
                pc += 3;
                addressWrite((l1 << 8) + k1 + 1, (sp & 0xff00) >> 8);
                addressWrite((l1 << 8) + k1, sp & 0xff);
                break;

            case 10: // '\n'
                pc++;
                a = (addressRead((b << 8) + c)&0xff);
                break;

            case 14: // '\016'
                pc += 2;
                c = k1;
                break;

            case 17: // '\021'
                pc += 3;
                d = l1;
                e = k1;
                break;

            case 18: // '\022'
                pc++;
                addressWrite((d << 8) + e, a);
                break;

            case 22: // '\026'
                pc += 2;
                d = k1;
                break;

            case 26: // '\032'
                pc++;
                a = (addressRead((d << 8) + e)&0xff);
                break;

            case 62: // '>'
                pc += 2;
                a = k1;
                break;

            case 242: 
                pc++;
                a = (addressRead(65280 + c))&0xff;
                break;

            case 33: // '!'
                pc += 3;
                hl = (l1 << 8) + k1;
                break;

            case 34: // '"'
                pc++;
                addressWrite(hl, a);
                hl = hl + 1 & 0xffff;
                break;

            case 49: // '1'
                pc += 3;
                sp = (l1 << 8) + k1;
                break;

            case 50: // '2'
                pc++;
                addressWrite(hl, a);
                hl--;
                break;

            case 58: // ':'
                pc++;
                a = (addressRead(hl))&0xff;
                hl = hl - 1 & 0xffff;
                break;

            case 30: // '\036'
                pc += 2;
                e = k1;
                break;

            case 38: // '&'
                pc += 2;
                hl = hl & 0xff | k1 << 8;
                break;

            case 42: // '*'
                pc++;
                a = (addressRead(hl))&0xff;
                hl++;
                break;

            case 46: // '.'
                pc += 2;
                hl = hl & 0xff00 | k1;
                break;

            case 54: // '6'
                pc += 2;
                addressWrite(hl, k1);
                break;

            case 234: 
                pc += 3;
                addressWrite((l1 << 8) + k1, a);
                break;

            case 249: 
                pc++;
                sp = hl;
                break;

            case 250: 
                pc += 3;
                a = (addressRead((l1 << 8) + k1))&0xff;
                break;

            case 3: // '\003'
                pc++;
                c++;
                if(c == 256) {
                    b++;
                    c = 0;
                    if(b == 256)
                        b = 0;
                }
                break;

            case 4: // '\004'
                pc++;
                f &= F_CARRY;
                switch(b) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    b = 0;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    b = 16;
                    break;

                default:
                    b++;
                    break;
                }
                break;

            case 5: // '\005'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(b) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    b = 255;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    b = 15;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    b = 0;
                    break;

                default:
                    b--;
                    break;
                }
                break;

            case 7: // '\007'
                pc++;
                f = 0;
                a <<= 1;
                if((a & 0x100) != 0) {
                    f |= F_CARRY;
                    a |= 1;
                    a &= 0xff;
                }
                if(a == 0)
                    f |= F_ZERO;
                break;

            case 9: // '\t'
                pc++;
                hl += (b << 8) + c;
                if((hl & 0xffff0000) != 0) {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY | F_CARRY);
                    hl &= 0xffff;
                } else {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY);
                }
                break;

            case 11: // '\013'
                pc++;
                c--;
                if((c & 0xff00) != 0) {
                    c = 255;
                    b--;
                    if((b & 0xff00) != 0)
                        b = 255;
                }
                break;

            case 12: // '\f'
                pc++;
                f &= F_CARRY;
                switch(c) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    c = 0;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    c = 16;
                    break;

                default:
                    c++;
                    break;
                }
                break;

            case 13: // '\r'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(c) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    c = 255;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    c = 15;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    c = 0;
                    break;

                default:
                    c--;
                    break;
                }
                break;

            case 15: // '\017'
                pc++;
                if((a & 1) == 1)
                    f = F_CARRY;
                else
                    f = 0;
                a >>= 1;
                if((f & F_CARRY) == F_CARRY)
                    a |= 0x80;
                if(a == 0)
                    f |= F_ZERO;
                break;

            case 16: // '\020'
                pc += 2;
                if(gbcFeatures && (registers[77] & 1) == 1) {
                    int k2 = registers[77] & 0xfe;
                    if((k2 & 0x80) == 128) {
                        setDoubleSpeedCpu(false);
                        k2 &= 0x7f;
                    } else {
                        setDoubleSpeedCpu(true);
                        k2 |= 0x80;
                    }
                    registers[77] = (byte)k2;
                }
                break;

            case 19: // '\023'
                pc++;
                e++;
                if(e == 256) {
                    d++;
                    e = 0;
                    if(d == 256)
                        d = 0;
                }
                break;

            case 20: // '\024'
                pc++;
                f &= F_CARRY;
                switch(d) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    d = 0;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    d = 16;
                    break;

                default:
                    d++;
                    break;
                }
                break;

            case 21: // '\025'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(d) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    d = 255;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    d = 15;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    d = 0;
                    break;

                default:
                    d--;
                    break;
                }
                break;

            case 23: // '\027'
                pc++;
                int j;
                if((a & 0x80) == 128)
                    j = F_CARRY;
                else
                    j = 0;
                a <<= 1;
                if((f & F_CARRY) == F_CARRY)
                    a |= 1;
                a &= 0xff;
                if(a == 0)
                    j = (short)(j | F_ZERO);
                f = j;
                break;

            case 24: // '\030'
                pc += 2 + i2;
                break;

            case 25: // '\031'
                pc++;
                hl += (d << 8) + e;
                if((hl & 0xffff0000) != 0) {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY | F_CARRY);
                    hl &= 0xffff;
                } else {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY);
                }
                break;

            case 27: // '\033'
                pc++;
                e--;
                if((e & 0xff00) != 0) {
                    e = 255;
                    d--;
                    if((d & 0xff00) != 0)
                        d = 255;
                }
                break;

            case 28: // '\034'
                pc++;
                f &= F_CARRY;
                switch(e) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    e = 0;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    e = 16;
                    break;

                default:
                    e++;
                    break;
                }
                break;

            case 29: // '\035'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(e) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    e = 255;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    e = 15;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    e = 0;
                    break;

                default:
                    e--;
                    break;
                }
                break;

            case 31: // '\037'
                pc++;
                int k;
                if((a & 1) == 1)
                    k = F_CARRY;
                else
                    k = 0;
                a >>= 1;
                if((f & F_CARRY) == F_CARRY)
                    a |= 0x80;
                if(a == 0)
                    k = (short)(k | F_ZERO);
                f = k;
                break;

            case 32: // ' '
                if((f & 0x80) == 0)
                    pc += 2 + i2;
                else
                    pc += 2;
                break;

            case 35: // '#'
                pc++;
                hl = hl + 1 & 0xffff;
                break;

            case 36: // '$'
                pc++;
                f &= F_CARRY;
                switch((hl & 0xff00) >> 8) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    hl &= 0xff;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    hl = hl & 0xff | 0x10;
                    break;

                default:
                    hl += 256;
                    break;
                }
                break;

            case 37: // '%'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch((hl & 0xff00) >> 8) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    hl = hl & 0xff | 0xff00;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    hl = hl & 0xff | 0xf00;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    hl &= 0xff;
                    break;

                default:
                    hl = hl & 0xff | (hl & 0xff00) - 256;
                    break;
                }
                break;

            case 39: // '\''
                pc++;
                int l2 = (a & 0xf0) >> 4;
                int i3 = a & 0xf;
                int l = (short)(f & F_SUBTRACT);
                if((f & F_SUBTRACT) == 0) {
                    if((f & F_CARRY) == 0) {
                        if(l2 <= 8 && i3 >= 10 && (f & F_HALFCARRY) == 0)
                            a += 6;
                        if(l2 <= 9 && i3 <= 3 && (f & F_HALFCARRY) == F_HALFCARRY)
                            a += 6;
                        if(l2 >= 10 && i3 <= 9 && (f & F_HALFCARRY) == 0) {
                            a += 96;
                            l = (short)(l | F_CARRY);
                        }
                        if(l2 >= 9 && i3 >= 10 && (f & F_HALFCARRY) == 0) {
                            a += 102;
                            l = (short)(l | F_CARRY);
                        }
                        if(l2 >= 10 && i3 <= 3 && (f & F_HALFCARRY) == F_HALFCARRY) {
                            a += 102;
                            l = (short)(l | F_CARRY);
                        }
                    } else {
                        if(l2 <= 2 && i3 <= 9 && (f & F_HALFCARRY) == 0) {
                            a += 96;
                            l = (short)(l | F_CARRY);
                        }
                        if(l2 <= 2 && i3 >= 10 && (f & F_HALFCARRY) == 0) {
                            a += 102;
                            l = (short)(l | F_CARRY);
                        }
                        if(l2 <= 3 && i3 <= 3 && (f & F_HALFCARRY) == F_HALFCARRY) {
                            a += 102;
                            l = (short)(l | F_CARRY);
                        }
                    }
                } else
                if((f & F_CARRY) == 0) {
                    if(l2 <= 8 && i3 >= 6 && (f & F_HALFCARRY) == F_HALFCARRY)
                        a += 250;
                } else {
                    if(l2 >= 7 && i3 <= 9 && (f & F_HALFCARRY) == 0) {
                        a += 160;
                        l = (short)(l | F_CARRY);
                    }
                    if(l2 >= 6 && i3 >= 6 && (f & F_HALFCARRY) == F_HALFCARRY) {
                        a += 154;
                        l = (short)(l | F_CARRY);
                    }
                }
                a &= 0xff;
                if(a == 0)
                    l = (short)(l | F_ZERO);
                f = l;
                break;

            case 40: // '('
                if((f & F_ZERO) == F_ZERO)
                    pc += 2 + i2;
                else
                    pc += 2;
                break;

            case 41: // ')'
                pc++;
                hl += hl;
                if((hl & 0xffff0000) != 0) {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY | F_CARRY);
                    hl &= 0xffff;
                } else {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY);
                }
                break;

            case 43: // '+'
                pc++;
                if(hl == 0)
                    hl = 65535;
                else
                    hl--;
                break;

            case 44: // ','
                pc++;
                f &= F_CARRY;
                switch(hl & 0xff) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    hl &= 0xff00;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    hl++;
                    break;

                default:
                    hl++;
                    break;
                }
                break;

            case 45: // '-'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(hl & 0xff) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    hl = hl & 0xff00 | 0xff;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    hl = hl & 0xff00 | 0xf;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    hl &= 0xff00;
                    break;

                default:
                    hl = hl & 0xff00 | (hl & 0xff) - 1;
                    break;
                }
                break;

            case 47: // '/'
                pc++;
                //c1 = '\200';
                a = (short)(~a & 0xff);
                f = (short)(f & (F_CARRY | F_ZERO) | F_SUBTRACT | F_HALFCARRY);
                break;

            case 48: // '0'
                if((f & F_CARRY) == 0)
                    pc += 2 + i2;
                else
                    pc += 2;
                break;

            case 51: // '3'
                pc++;
                sp = sp + 1 & 0xffff;
                break;

            case 52: // '4'
                pc++;
                f &= F_CARRY;
                int word0 = (addressRead(hl)&0xff);
                switch(word0) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    addressWrite(hl, 0);
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    addressWrite(hl, 16);
                    break;

                default:
                    addressWrite(hl, word0 + 1);
                    break;
                }
                break;

            case 53: // '5'
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                int word1 = (addressRead(hl)&0xff);
                switch(word1) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    addressWrite(hl, 255);
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    addressWrite(hl, 15);
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    addressWrite(hl, 0);
                    break;

                default:
                    addressWrite(hl, word1 - 1);
                    break;
                }
                break;

            case 55: // '7'
                pc++;
                f &= F_ZERO;
                f |= F_CARRY;
                break;

            case 56: // '8'
                if((f & F_CARRY) == F_CARRY)
                    pc += 2 + i2;
                else
                    pc += 2;
                break;

            case 57: // '9'
                pc++;
                hl += sp;
                if((hl & 0xffff0000) != 0) {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY | F_CARRY);
                    hl &= 0xffff;
                } else {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY);
                }
                break;

            case 59: // ';'
                pc++;
                sp = sp - 1 & 0xffff;
                break;

            case 60: // '<'
                pc++;
                f &= F_CARRY;
                switch(a) {
                case 255: 
                    f |= F_HALFCARRY + F_ZERO;
                    a = 0;
                    break;

                case 15: // '\017'
                    f |= F_HALFCARRY;
                    a = 16;
                    break;

                default:
                    a++;
                    break;
                }
                break;

            case 61: // '='
                pc++;
                f &= F_CARRY;
                f |= F_SUBTRACT;
                switch(a) {
                case 0: // '\0'
                    f |= F_HALFCARRY;
                    a = 255;
                    break;

                case 16: // '\020'
                    f |= F_HALFCARRY;
                    a = 15;
                    break;

                case 1: // '\001'
                    f |= F_ZERO;
                    a = 0;
                    break;

                default:
                    a--;
                    break;
                }
                break;

            case 63: // '?'
                pc++;
                if((f & F_CARRY) == 0)
                    f = (short)(f & F_ZERO | F_CARRY);
                else
                    f = (short)(f & F_ZERO);
                break;

            case 82: // 'R'
                terminate = true;
                break;

            case 118: // 'v'
                 while(!interruptsArmed)  {
                    instrCount = nextTimedInterrupt;
                    initiateInterrupts();
                }/*
                while(registers[15] == 0)  {
                    initiateInterrupts();
                    instrCount++;
                }*/
                pc++;//????
                break;

            case 175: 
                pc++;
                a = 0;
                f = 128;
                break;

            case 192: 
                if((f & F_ZERO) == 0) {
                    pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                    sp += 2;
                } else {
                    pc++;
                }
                break;

            case 193: 
                pc++;
                c = (addressRead(sp)&0xff);
                b = (addressRead(sp + 1)&0xff);
                sp += 2;
                break;

            case 194: 
                if((f & F_ZERO) == 0)
                    pc = (l1 << 8) + k1;
                else
                    pc += 3;
                break;

            case 195: 
                pc = (l1 << 8) + k1;
                break;

            case 196: 
                if((f & F_ZERO) == 0) {
                    pc += 3;
                    sp -= 2;
                    addressWrite(sp + 1, pc >> 8);
                    addressWrite(sp, pc & 0xff);
                    pc = (l1 << 8) + k1;
                } else {
                    pc += 3;
                }
                break;

            case 197: 
                pc++;
                sp -= 2;
                sp &= 0xffff;
                addressWrite(sp, c);
                addressWrite(sp + 1, b);
                break;

            case 198: 
                pc += 2;
                f = 0;
                if(((a & 0xf) + (k1 & 0xf) & 0xf0) != 0)
                    f |= F_HALFCARRY;
                a += k1;
                if((a & 0xff00) != 0)
                    if(a == 256) {
                        f |= F_ZERO + F_CARRY + F_HALFCARRY;
                        a = 0;
                    } else {
                        f |= F_CARRY + F_HALFCARRY;
                        a &= 0xff;
                    }
                break;

            case 207: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 8;
                break;

            case 200: 
                if((f & F_ZERO) == F_ZERO) {
                    pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                    sp += 2;
                } else {
                    pc++;
                }
                break;

            case 201: 
                pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                sp += 2;
                break;

            case 202: 
                if((f & F_ZERO) == F_ZERO)
                    pc = (l1 << 8) + k1;
                else
                    pc += 3;
                break;

            case 203: 
                pc += 2;
                int j3 = k1 & 7;
                short word6 = (short)registerRead(j3);
                if((k1 & 0xc0) == 0) {
                    switch(k1 & 0xf8) {
                    case 0: // '\0'
                        if((word6 & 0x80) == 128)
                            f = F_CARRY;
                        else
                            f = 0;
                        word6 <<= 1;
                        if((f & F_CARRY) == F_CARRY)
                            word6 |= 1;
                        word6 &= 0xff;
                        if(word6 == 0)
                            f |= F_ZERO;
                        registerWrite(j3, word6);
                        break;

                    case 8: // '\b'
                        if((word6 & 1) == 1)
                            f = F_CARRY;
                        else
                            f = 0;
                        word6 >>= 1;
                        if((f & F_CARRY) == F_CARRY)
                            word6 |= 0x80;
                        if(word6 == 0)
                            f |= F_ZERO;
                        registerWrite(j3, word6);
                        break;

                    case 16: // '\020'
                        
                        if((word6 & 0x80) == 128)
                            i1 = F_CARRY;
                        else
                            i1 = 0;
                        word6 <<= 1;
                        if((f & F_CARRY) == F_CARRY)
                            word6 |= 1;
                        word6 &= 0xff;
                        if(word6 == 0)
                            i1 = (short)(i1 | F_ZERO);
                        f = i1;
                        registerWrite(j3, word6);
                        break;

                    case 24: // '\030'
                       
                        if((word6 & 1) == 1)
                            j1 = F_CARRY;
                        else
                            j1 = 0;
                        word6 >>= 1;
                        if((f & F_CARRY) == F_CARRY)
                            word6 |= 0x80;
                        if(word6 == 0)
                            j1 = (short)(j1 | F_ZERO);
                        f = j1;
                        registerWrite(j3, word6);
                        break;

                    case 32: // ' '
                        if((word6 & 0x80) == 128)
                            f = F_CARRY;
                        else
                            f = 0;
                        word6 <<= 1;
                        word6 &= 0xff;
                        if(word6 == 0)
                            f |= F_ZERO;
                        registerWrite(j3, word6);
                        break;

                    case 40: // '('
                        word7 = 0;
                        word7 = (short)(word6 & 0x80);
                        if((word6 & 1) == 1)
                            f = F_CARRY;
                        else
                            f = 0;
                        word6 >>= 1;
                        word6 |= word7;
                        if(word6 == 0)
                            f |= F_ZERO;
                        registerWrite(j3, word6);
                        break;

                    case 48: // '0'
                        word6 = (short)((word6 & 0xf) << 4 | (word6 & 0xf0) >> 4);
                        if(word6 == 0)
                            f = F_ZERO;
                        else
                            f = 0;
                        registerWrite(j3, word6);
                        break;

                    case 56: // '8'
                        if((word6 & 1) == 1)
                            f = F_CARRY;
                        else
                            f = 0;
                        word6 >>= 1;
                        if(word6 == 0)
                            f |= F_ZERO;
                        registerWrite(j3, word6);
                        break;
                    }
                } else {
                    int k3 = (k1 & 0x38) >> 3;
                    if((k1 & 0xc0) == 64) {
                        short word3 = (short)(1 << k3);
                        if((word6 & word3) != 0)
                            f = (short)(f & F_CARRY | F_HALFCARRY);
                        else
                            f = (short)(f & F_CARRY | F_HALFCARRY + F_ZERO);
                    }
                    if((k1 & 0xc0) == 128) {
                        short word4 = (short)(255 - (1 << k3));
                        word6 &= word4;
                        registerWrite(j3, word6);
                    }
                    if((k1 & 0xc0) == 192) {
                        short word5 = (short)(1 << k3);
                        word6 |= word5;
                        registerWrite(j3, word6);
                    }
                }
                break;

            case 204: 
                if((f & F_ZERO) == F_ZERO) {
                    pc += 3;
                    sp -= 2;
                    addressWrite(sp + 1, pc >> 8);
                    addressWrite(sp, pc & 0xff);
                    pc = (l1 << 8) + k1;
                } else {
                    pc += 3;
                }
                break;

            case 205: 
                pc += 3;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = (l1 << 8) + k1;
                break;

            case 206: 
                pc += 2;
                if((f & F_CARRY) != 0)
                    k1++;
                f = 0;
                if(((a & 0xf) + (k1 & 0xf) & 0xf0) != 0)
                    f |= F_HALFCARRY;
                a += k1;
                if((a & 0xff00) != 0)
                    if(a == 256) {
                        f |= F_ZERO + F_CARRY + F_HALFCARRY;
                        a = 0;
                    } else {
                        f |= F_CARRY + F_HALFCARRY;
                        a &= 0xff;
                    }
                break;

            case 199: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 0;
                break;

            case 208: 
                if((f & F_CARRY) == 0) {
                    pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                    sp += 2;
                } else {
                    pc++;
                }
                break;

            case 209: 
                pc++;
                e = (addressRead(sp)&0xff);
                d = (addressRead(sp + 1)&0xff);
                sp += 2;
                break;

            case 210: 
                if((f & F_CARRY) == 0)
                    pc = (l1 << 8) + k1;
                else
                    pc += 3;
                break;

            case 212: 
                if((f & F_CARRY) == 0) {
                    pc += 3;
                    sp -= 2;
                    addressWrite(sp + 1, pc >> 8);
                    addressWrite(sp, pc & 0xff);
                    pc = (l1 << 8) + k1;
                } else {
                    pc += 3;
                }
                break;

            case 213: 
                pc++;
                sp -= 2;
                sp &= 0xffff;
                addressWrite(sp, e);
                addressWrite(sp + 1, d);
                break;

            case 214: 
                pc += 2;
                f = F_SUBTRACT;
                if(((a & 0xf) - (k1 & 0xf) & 0xfff0) != 0)
                    f |= F_HALFCARRY;
                a -= k1;
                if((a & 0xff00) != 0) {
                    a &= 0xff;
                    f |= F_CARRY;
                }
                if(a == 0)
                    f |= F_ZERO;
                break;

            case 215: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 16;
                break;

            case 216: 
                if((f & F_CARRY) == F_CARRY) {
                    pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                    sp += 2;
                } else {
                    pc++;
                }
                break;

            case 217: 
                interruptsEnabled = true;
                inInterrupt = false;
                pc = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                sp += 2;
                break;

            case 218: 
                if((f & F_CARRY) == F_CARRY)
                    pc = (l1 << 8) + k1;
                else
                    pc += 3;
                break;

            case 220: 
                if((f & F_CARRY) == F_CARRY) {
                    pc += 3;
                    sp -= 2;
                    addressWrite(sp + 1, pc >> 8);
                    addressWrite(sp, pc & 0xff);
                    pc = (l1 << 8) + k1;
                } else {
                    pc += 3;
                }
                break;

            case 222: 
                pc += 2;
                if((f & F_CARRY) != 0)
                    k1++;
                f = F_SUBTRACT;
                if(((a & 0xf) - (k1 & 0xf) & 0xfff0) != 0)
                    f |= F_HALFCARRY;
                a -= k1;
                if((a & 0xff00) != 0) {
                    a &= 0xff;
                    f |= F_CARRY;
                }
                if(a == 0)
                    f |= F_ZERO;
                break;

            case 223: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 24;
                break;

            case 224: 
                pc += 2;
                addressWrite(65280 + k1, a);
                break;

            case 225: 
                pc++;
                hl = ((addressRead(sp + 1)&0xff) << 8) + (addressRead(sp)&0xff);
                sp += 2;
                break;

            case 226: 
                pc++;
                addressWrite(65280 + c, a);
                break;

            case 229: 
                pc++;
                sp -= 2;
                sp &= 0xffff;
                addressWrite(sp + 1, hl >> 8);
                addressWrite(sp, hl & 0xff);
                break;

            case 230: 
                pc += 2;
                a &= k1;
                if(a == 0)
                    f = F_ZERO;
                else
                    f = 0;
                break;

            case 231: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 32;
                break;

            case 232: 
                pc += 2;
                sp += i2;
                if((sp & 0xffff0000) != 0) {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY | F_CARRY);
                    sp &= 0xffff;
                } else {
                    f = (short)(f & F_SUBTRACT + F_ZERO + F_HALFCARRY);
                }
                break;

            case 233: 
                pc++;
                pc = hl;
                break;

            case 238: 
                pc += 2;
                a ^= k1;
                if(a == 0)
                    f = F_ZERO;
                else
                    f = 0;
                break;

            case 239: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 40;
                break;

            case 240: 
                pc += 2;
                a = (addressRead(65280 + k1)&0xff);
                break;

            case 241: 
                pc++;
                f = (addressRead(sp)&0xff);
                a = (addressRead(sp + 1)&0xff);
                sp += 2;
                break;

            case 243: 
                pc++;
                interruptsEnabled = false;
                break;

            case 245: 
                pc++;
                sp -= 2;
                sp &= 0xffff;
                addressWrite(sp, f);
                addressWrite(sp + 1, a);
                break;

            case 246: 
                pc += 2;
                a |= k1;
                if(a == 0)
                    f = F_ZERO;
                else
                    f = 0;
                break;

            case 247: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 48;
                break;

            case 248: 
                pc += 2;
                hl = sp + i2;
                if((hl & 0x10000) != 0) {
                    f = F_CARRY;
                    hl &= 0xffff;
                } else {
                    f = 0;
                }
                break;

            case 251: 
                pc++;
                nextInterruptEnable = instrCount + 1;
                nextTimedInterrupt = nextInterruptEnable;
                ieDelay = 1;//?
                break;

            case 254: 
                pc += 2;
                f = 0;
                if(k1 == a)
                    f |= F_ZERO;
                else
                if(a < k1)
                    f |= F_CARRY;
                break;

            case 255: 
                pc++;
                sp -= 2;
                addressWrite(sp + 1, pc >> 8);
                addressWrite(sp, pc & 0xff);
                pc = 56;
                break;

            case 64: // '@'
            case 65: // 'A'
            case 66: // 'B'
            case 67: // 'C'
            case 68: // 'D'
            case 69: // 'E'
            case 70: // 'F'
            case 71: // 'G'
            case 72: // 'H'
            case 73: // 'I'
            case 74: // 'J'
            case 75: // 'K'
            case 76: // 'L'
            case 77: // 'M'
            case 78: // 'N'
            case 79: // 'O'
            case 80: // 'P'
            case 81: // 'Q'
            case 83: // 'S'
            case 84: // 'T'
            case 85: // 'U'
            case 86: // 'V'
            case 87: // 'W'
            case 88: // 'X'
            case 89: // 'Y'
            case 90: // 'Z'
            case 91: // '['
            case 92: // '\\'
            case 93: // ']'
            case 94: // '^'
            case 95: // '_'
            case 96: // '`'
            case 97: // 'a'
            case 98: // 'b'
            case 99: // 'c'
            case 100: // 'd'
            case 101: // 'e'
            case 102: // 'f'
            case 103: // 'g'
            case 104: // 'h'
            case 105: // 'i'
            case 106: // 'j'
            case 107: // 'k'
            case 108: // 'l'
            case 109: // 'm'
            case 110: // 'n'
            case 111: // 'o'
            case 112: // 'p'
            case 113: // 'q'
            case 114: // 'r'
            case 115: // 's'
            case 116: // 't'
            case 117: // 'u'
            case 119: // 'w'
            case 120: // 'x'
            case 121: // 'y'
            case 122: // 'z'
            case 123: // '{'
            case 124: // '|'
            case 125: // '}'
            case 126: // '~'
            case 127: // '\177'
            case 128: 
            case 129: 
            case 130: 
            case 131: 
            case 132: 
            case 133: 
            case 134: 
            case 135: 
            case 136: 
            case 137: 
            case 138: 
            case 139: 
            case 140: 
            case 141: 
            case 142: 
            case 143: 
            case 144: 
            case 145: 
            case 146: 
            case 147: 
            case 148: 
            case 149: 
            case 150: 
            case 151: 
            case 152: 
            case 153: 
            case 154: 
            case 155: 
            case 156: 
            case 157: 
            case 158: 
            case 159: 
            case 160: 
            case 161: 
            case 162: 
            case 163: 
            case 164: 
            case 165: 
            case 166: 
            case 167: 
            case 168: 
            case 169: 
            case 170: 
            case 171: 
            case 172: 
            case 173: 
            case 174: 
            case 176: 
            case 177: 
            case 178: 
            case 179: 
            case 180: 
            case 181: 
            case 182: 
            case 183: 
            case 184: 
            case 185: 
            case 186: 
            case 187: 
            case 188: 
            case 189: 
            case 190: 
            case 191: 
            case 211: 
            case 219: 
            case 221: 
            case 227: 
            case 228: 
            case 235: 
            case 236: 
            case 237: 
            case 244: 
            case 252: 
            case 253: 
            default:
                if((word2 & 0xc0) == 128) {
                    pc++;
                    int l3 = registerRead(word2 & 7);
                    switch((word2 & 0x38) >> 3) {
                    case 1: // '\001'
                        if((f & F_CARRY) != 0)
                            l3++;
                        // fall through

                    case 0: // '\0'
                        f = 0;
                        if(((a & 0xf) + (l3 & 0xf) & 0xf0) != 0)
                            f |= F_HALFCARRY;
                        a += l3;
                        if(a == 0)
                            f |= F_ZERO;
                        if((a & 0xff00) != 0)
                            if(a == 256) {
                                f |= F_ZERO + F_CARRY + F_HALFCARRY;
                                a = 0;
                            } else {
                                f |= F_CARRY + F_HALFCARRY;
                                a &= 0xff;
                            }
                        break;

                    case 3: // '\003'
                        if((f & F_CARRY) != 0)
                            l3++;
                        // fall through

                    case 2: // '\002'
                        f = F_SUBTRACT;
                        if(((a & 0xf) - (l3 & 0xf) & 0xfff0) != 0)
                            f |= F_HALFCARRY;
                        a -= l3;
                        if((a & 0xff00) != 0) {
                            a &= 0xff;
                            f |= F_CARRY;
                        }
                        if(a == 0)
                            f |= F_ZERO;
                        break;

                    case 4: // '\004'
                        a &= l3;
                        if(a == 0)
                            f = F_ZERO;
                        else
                            f = 0;
                        break;

                    case 5: // '\005'
                        a ^= l3;
                        if(a == 0)
                            f = F_ZERO;
                        else
                            f = 0;
                        break;

                    case 6: // '\006'
                        a |= l3;
                        if(a == 0)
                            f = F_ZERO;
                        else
                            f = 0;
                        break;

                    case 7: // '\007'
                        f = F_SUBTRACT;
                        if(a == l3)
                            f |= F_ZERO;
                        if(a < l3)
                            f |= F_CARRY;
                        if((a & 0xf) < (l3 & 0xf))
                            f |= F_HALFCARRY;
                        break;
                    }
                } else
                if((word2 & 0xc0) == 64) {
                    pc++;
                    registerWrite((word2 & 0x38) >> 3, registerRead(word2 & 7));
                } else {
                    terminate = true;
                    pc++;
                }
                break;
            }
            if(ieDelay != -1)
                if(ieDelay > 0) {
                    ieDelay--;
                } else {
                    interruptsEnabled = true;
                    ieDelay = -1;
                }
            if(interruptsEnabled)
                checkInterrupts(); 
            if(instrCount >= nextTimedInterrupt)
                initiateInterrupts();
        }

        running = false;
        terminate = false;
    }
/*
    short unsign(byte byte0) {
        if(byte0 < 0)
            return (short)(256 + byte0);
        else
            return (short)byte0;
    }

    short unsign(short word0) {
        if(word0 < 0)
            return (short)(256 + word0);
        else
            return word0;
    }
*/

    void mapRom(int i) {
        currentBank = i;
        pageStart = 16384 * i;
    }

    void resetRom() {
        mapRom(1);
    }

    void saveMapping() {
        if(cartType != 0 && savedBank == -1)
            savedBank = currentBank;
    }

    void restoreMapping() {
        if(savedBank != -1) {
            addressWrite(8192, savedBank);
            savedBank = -1;
        }
    }

    void addressWriteRom(int i, int j) {
        //boolean flag = false;
        switch(cartType) {
        case 0: // '\0'
        case 4: // '\004'
        case 7: // '\007'
        case 8: // '\b'
        case 9: // '\t'
        case 10: // '\n'
        case 11: // '\013'
        case 12: // '\f'
        case 13: // '\r'
        case 14: // '\016'
        case 15: // '\017'
        case 16: // '\020'
        case 17: // '\021'
        case 18: // '\022'
        case 19: // '\023'
        case 20: // '\024'
        case 21: // '\025'
        case 22: // '\026'
        case 23: // '\027'
        case 24: // '\030'
        default:
            break;

        case 1: // '\001'
        case 2: // '\002'
        case 3: // '\003'
            if(i >= 40960 && i <= 49151 && ramEnabled) {
                int k = (i - 40960) + ramPageStart;
                ram[k] = (byte)j;
            }
            if(i >= 8192 && i <= 16383) {
                int l = j & 0x1f;
                if(l == 0)
                    l = 1;
                mapRom(currentBank & 0x60 | l);
            } else
            if(i >= 24576 && i <= 32767) {
                if((j & 1) == 1)
                    mbc1LargeRamMode = true;
                else
                    mbc1LargeRamMode = false;
            } else
            if(i <= 8191) {
                if((j & 0xf) == 10)
                    ramEnabled = true;
                else
                    ramEnabled = false;
            } else
            if(i <= 24575 && i >= 16384)
                if(mbc1LargeRamMode) {
                    ramBank = j & 3;
                    ramPageStart = ramBank * 8192;
                } else {
                    mapRom(currentBank & 0x1f | (j & 3) << 5);
                }
            break;

        case 5: // '\005'
        case 6: // '\006'
            if(i >= 8192 && i <= 16383 && (i & 0x100) != 0) {
                int i1 = j & 0x1f;
                if(i1 == 0)
                    i1 = 1;
                mapRom(i1);
            }
            if(i >= 40960 && i <= 49151 && ramEnabled)
                ram[(i - 40960) + ramPageStart] = (byte)j;
            break;

        case 25: // '\031'
        case 26: // '\032'
        case 27: // '\033'
        case 28: // '\034'
        case 29: // '\035'
        case 30: // '\036'
            if(i >= 8192 && i <= 12287) {
                int j1 = currentBank & 0xff00 | j;
                mapRom(j1);
            }
            if(i >= 12288 && i <= 16383) {
                int k1 = currentBank & 0xff | (j & 1) << 8;
                mapRom(k1);
            }
            if(i >= 16384 && i <= 24575) {
                ramBank = j & 7;
                ramPageStart = ramBank * 8192;
            }
            if(i >= 40960 && i <= 49151)
                ram[(i - 40960) + ramPageStart] = (byte)j;
            break;
        }
    }
/*
    void loadSRAM() {
        try {
            RecordStore recordstore = RecordStore.openRecordStore("gameboysram", true);
            ram = recordstore.getRecord(1);
            recordstore.closeRecordStore();
        }
        catch(Exception exception) {
            System.out.println("error cargando sram:" + exception);
            ram = new byte[8192];
        }
    }

    void saveSRAM() {
        try {
          //  System.out.println("llego1");
            RecordStore recordstore = RecordStore.openRecordStore("gameboysram", true);
//            System.out.println("llego2");
            recordstore.setRecord(1, ram, 0, 8192);
            recordstore.closeRecordStore();
//            System.out.println("sram salvada :)");
        }
        catch(Exception exception) {
            try {
                System.out.println("error salvando sram:" + exception);
  //              System.out.println("llego1");
                RecordStore recordstore1 = RecordStore.openRecordStore("gameboysram", true);
//                System.out.println("llego2");
                int i = recordstore1.addRecord(new byte[0], 0, 0);
//                System.out.println("llego3");
//                System.out.println(i);
                recordstore1.setRecord(1, ram, 0, 8192);
                recordstore1.closeRecordStore();
//                System.out.println("sram salvada :)");
            }
            catch(Exception exception1) {
                System.out.println("error salvando sram 2:" + exception1);
            }
        }
    }
*/
    void reset(struct Paleta *apaletagameboy, struct Paleta *apaletagameboy1) {
      int i,j;
            //backgroundPalette = paletagameboy;
            for(i = 0; i < 8; i++) {
                gbcBackground[i] = apaletagameboy[i];
                gbcSprite[i] = apaletagameboy1[i];
            }
            for(j = 0; j < 255; j++)
                ioWrite(j, (short)0);
            ioWrite(64, (short)145);
            ioWrite(15, (short)1);
            hdmaRunning = false;
    }
/*
    void toggleKey(String s) {
        if(s.equals("a"))
            padA = !padA;
        else
        if(s.equals("b"))
            padB = !padB;
        else
        if(s.equals("up"))
            padUp = !padUp;
        else
        if(s.equals("down"))
            padDown = !padDown;
        else
        if(s.equals("left"))
            padLeft = !padLeft;
        else
        if(s.equals("right"))
            padRight = !padRight;
        else
        if(s.equals("select"))
            padSelect = !padSelect;
        else
        if(s.equals("start"))
            padStart = !padStart;
    }
*/
    void performHdma() {
        int i = ((registers[81]&0xff) << 8) + ((registers[82]&0xff) & 0xf0);
        int j = (((registers[83]&0xff) & 0x1f) << 8) + ((registers[84]&0xff) & 0xf0) + 32768;
        for(int k = 0; k < 16; k++)
            addressWrite(j + k, addressRead(i + k));

        i += 16;
        j += 16;
        registers[81] = (byte)((i & 0xff00) >> 8);
        registers[82] = (byte)(i & 0xf0);
        registers[83] = (byte)((j & 0x1f00) >> 8);
        registers[84] = (byte)(j & 0xf0);
        int l = (registers[85]&0xff);
        if(l == 0) {
            registers[85] = -1;
            hdmaRunning = false;
        } else {
            l--;
            registers[85] = (byte)l;
        }
    }

    byte ioRead(int i) {
    	int j,k,l;
        if(i > 75);
        switch(i) {
        case 65: // 'A'
            j = 0;
            if(registers[68] == registers[69])
                j |= 4;
            k = (instrCount & INSTRS_PER_HBLANK);
            l = (INSTRS_PER_HBLANK+1) / 6;
            if((registers[68]&0xff) > 144)
                j |= 1;
            else
            if(k > l * 3)
                if(k <= l * 4)
                    j |= 2;
                else
                    j |= 3;
            return (byte)j;

        case 85: // 'U'
            return registers[85];

        case 105: // 'i'
            if(gbcFeatures) {
                int i1 = (registers[104] & 0x38) >> 3;
                return (byte)getGbcColours(gbcBackground+i1,((registers[104]&0xff) & 6) >> 1, ((registers[104]&0xff) & 1) == 1);
            } else { return registers[i]; }

        case 107: // 'k'
            if(gbcFeatures) {
                int j1 = (registers[106] & 0x38) >> 3;
                return (byte)getGbcColours(gbcSprite+j1,((registers[106]&0xff) & 6) >> 1, ((registers[106]&0xff) & 1) == 1);
            } else {
                return registers[i];
            }
        }
        return registers[i];
    }

    void ioWrite(int i, short word0) {
      int l,i1;
      short word1;
        switch(i) {
        case 0: // '\0'
            word1 = 255;
            if((word0 & 0x10) == 0) {
                if(padRight)
                    word1--;
                if(padLeft)
                    word1 -= 2;
                if(padUp)
                    word1 -= 4;
                if(padDown)
                    word1 -= 8;
            }
            if((word0 & 0x20) == 0) {
                if(padA)
                    word1--;
                if(padB)
                    word1 -= 2;
                if(padSelect)
                    word1 -= 4;
                if(padStart)
                    word1 -= 8;
            }
            registers[0] = (byte)word1;
            break;

        case 2: // '\002'
            registers[2] = (byte)word0;
            break;

        case 4: // '\004'
            registers[4] = 0;
            break;

        case 7: // '\007'
            if((word0 & 4) == 0)
                timaEnabled = false;
            else
                timaEnabled = true;
            int j = INSTRS_PER_VBLANK * 60;
            int k = word0 & 3;
            switch(k) {
            case 0: // '\0'
                instrsPerTima = j / 4096;
                break;

            case 1: // '\001'
                instrsPerTima = j / 0x40000;
                break;

            case 2: // '\002'
                instrsPerTima = j / 0x10000;
                break;

            case 3: // '\003'
                instrsPerTima = j / 16384;
                break;
            }
            break;

        case 64: // '@'
            bgEnabled = true;
            if((word0 & 0x20) == 32)
                winEnabled = true;
            else
                winEnabled = false;
            if((word0 & 0x10) == 16)
                bgWindowDataSelect = true;
            else
                bgWindowDataSelect = false;
            if((word0 & 8) == 8)
                hiBgTileMapAddress = true;
            else
                hiBgTileMapAddress = false;
            if((word0 & 4) == 4)
                doubledSprites = true;
            else
                doubledSprites = false;
            if((word0 & 2) == 2)
                spritesEnabled = true;
            else
                spritesEnabled = false;
            if((word0 & 1) == 0) {
                bgEnabled = false;
                winEnabled = false;
            }
            registers[64] = (byte)word0;
            break;

        case 66: // 'B'
            registers[66] = (byte)word0;
            break;

        case 67: // 'C'
            registers[67] = (byte)word0;
            break;

        case 70: // 'F'
            l = word0 << 8;
            for(i1 = 0; i1 < 160; i1++)
                addressWrite(65024 + i1, addressRead(l + i1));

            break;

        case 71: // 'G'
            decodePalette(&backgroundPalette,word0);
            if(registers[i] != (byte)word0)
                registers[i] = (byte)word0;
            break;

        case 72: // 'H'
            decodePalette(&obj1Palette,word0);
            if(registers[i] != (byte)word0)
                registers[i] = (byte)word0;
            break;

        case 73: // 'I'
            decodePalette(&obj2Palette,word0);
            if(registers[i] != (byte)word0)
                registers[i] = (byte)word0;
            break;

        case 79: // 'O'
            if(gbcFeatures) {
                tileStart = (word0 & 1) * 384;
                //vidRamStart = (word0 & 1) * 8192;
                vidRamStart = (word0 & 1) * 8192;
            }
            registers[79] = (byte)word0;
            break;

        case 85: // 'U'
            if(!hdmaRunning && (registers[85] & 0x80) == 0 && (word0 & 0x80) == 0) {
                int j1 = ((registers[81]&0xff) << 8) + ((registers[82]&0xff) & 0xf0);
                int i2 = (((registers[83]&0xff) & 0x1f) << 8) + ((registers[84]&0xff) & 0xf0) + 32768;
                int j2 = ((word0&0xff) & 0x7f) * 16 + 16;
                if(j2 > 2048)
                    j2 = 2048;
                for(int k2 = 0; k2 < j2; k2++)
                    addressWrite(i2 + k2, addressRead(j1 + k2));

            } else {
                if(((word0&0xff) & 0x80) == 128) {
                    hdmaRunning = true;
                    registers[85] = (byte)(word0 & 0x7f);
                    break;
                }
                if(hdmaRunning && ((word0&0xff) & 0x80) == 0)
                    hdmaRunning = false;
            }
            registers[85] = (byte)word0;
            break;

        case 105: // 'i'
            if(gbcFeatures) {
                int k1 = (registers[104] & 0x38) >> 3;
                setGbcColours(gbcBackground+k1,((registers[104]&0xff) & 6) >> 1, ((registers[104]&0xff) & 1) == 1, (word0&0xff));
                if(((registers[104]&0xff) & 0x80) != 0)
                    registers[104]++;
            }
            registers[105] = (byte)word0;
            break;

        case 107: // 'k'
            if(gbcFeatures) {
                int l1 = (registers[106] & 0x38) >> 3;
                setGbcColours(gbcSprite+l1,((registers[106]&0xff) & 6) >> 1, ((registers[106]&0xff) & 1) == 1, (word0&0xff));
                if(((registers[106]&0xff) & 0x80) != 0)
                    if((registers[106] & 0x3f) == 63)
                        registers[106] = -128;
                    else
                        registers[106]++;
            }
            registers[107] = (byte)word0;
            break;

        case 112: // 'p'
            if(gbcFeatures)
                if((word0 & 7) == 0 || (word0 & 7) == 1)
                    gbcRamBank = 1;
                else
                    gbcRamBank = word0 & 7;
            registers[112] = (byte)word0;
            break;

        default:
            registers[i] = (byte)word0;
            break;
        }
    }

///////////////////start ChipGraficos
    
    //	void keyPressed(int i) { keyGB(i,true);}
//	void keyReleased(int i) { keyGB(i,false);}

    //    case LEFT_BUTTON:if(miny<8) ++miny; break;
//    case RIGHT_BUTTON: if(miny>0) --miny; break;
//    case UP_BUTTON: if(minx>0) --minx; break;
//    case DOWN_BUTTON:  if(minx<10) ++minx; break;

    
    void keyGB(int i, boolean tr) {
            switch(i) {
            case 48: // '0'
                padSelect = tr;
                break;

            case 49: // '1'
                padUp = tr;
                padLeft = tr;
                break;

            case 50: // '2'
            case UP_BUTTON:
                padUp = tr;
                break;

            case 51: // '3'
                padUp = tr;
                padRight = tr;
                break;

            case 52: // '4'
            case LEFT_BUTTON:
                padLeft = tr;
                break;

            case 53: // '5'
                padStart = tr;
                break;

            case 54: // '6'
            case RIGHT_BUTTON:
                padRight = tr;
                break;

            case 56: // '8'
            case DOWN_BUTTON:
                padDown = tr;
                break;

            case 57: // '9'
                padRight = tr;
                padDown = tr;
                break;

            case 35: // '#'
                padA = tr;
                break;

            case 42: // '*'
            case ENTER_BUTTON:              
                padB = tr;
                break;

            case 55: // '7'
                padLeft = tr;
                padDown = tr;
                break;
            }
    }

//////////////MIDP2

    //int mag = 1;

    void ChipGrafico() {
        //backBuffer = new int[width * height];
    //    dmgcpu = cpu;
        PaletaInit(&backgroundPalette); //= new PaletaGameBoy(0, 1, 2, 3);
        PaletaInit(&obj1Palette);// = new PaletaGameBoy(0, 1, 2, 3);
        PaletaInit(&obj2Palette); //= new PaletaGameBoy(0, 1, 2, 3);
        for(int i = 0; i < 8; i++) {
            PaletaInit(gbcBackground+i);// = new PaletaGameBoy(0, 1, 2, 3);
            PaletaInit(gbcSprite+i);// = new PaletaGameBoy(0, 1, 2, 3);
        }
        //videoRam = new byte[16384];
        //for(int j = 0; j < 16384; j++)
        //    videoRam[j] = 0;

        //setFullScreenMode(true);/////////
        //ancho = getWidth();
        //alto = getHeight();
    }

    //void setMagnify(int i) {
//        mag = i;
//        width = i * 160;
//        height = i * 144;
//    }

    void dispose() {
        int i = getRgbEntry(&backgroundPalette,0);
        int j = backBufferlength;
        for(int k = 0; k < j; k++)
            backBuffer[k] = i;

    }

//    short addressRead(int i) {
//        return (short)videoRam[i + vidRamStart];
//    }

//    void addressWrite(int i, byte byte0) {
//        if(i < 6144)
//            videoRam[i + vidRamStart] = byte0;
//        else
//            videoRam[i + vidRamStart] = byte0;
//    }

    void drawSprites(int i) {
        int k,k2,l,l1,i1,j,j1;
        for(k2 = 0; k2 < 160; k2+=4) {
            j1 = oam[k2+3] & 0xff;
            if((j1 & 0x80) >> 7 == i) {
	            k = (oam[k2+1] & 0xff) - 8;
    	        l = (oam[k2] & 0xff) - 16;
        	    i1 = oam[k2+2] & 0xff;
                l1 = 0;
                if(doubledSprites)  i1 &= 0xfe;
                if(gbcFeatures) {
                    if((j1 & 8) != 0) {
                        j = 8192 + (i1 << 4);
                        i1 += 384;
                    } else {  j = i1 << 4; }
                    l1 += ((j1 & 7) << 2) + 32;
                } else {
                    j = i1 << 4;
                    if((j1 & 0x10) != 0) l1 |= 8;
                    else l1 |= 4;
                }
                if((j1 & 0x20) != 0) l1 |= 1;
                if((j1 & 0x40) != 0) l1 |= 2;
                dibuja(k,((l1 & 2)==0)?l:l+8, l1, j);
                if(doubledSprites)
                  dibuja(k,((l1 & 2)==0)?l+8:l, l1, j + 16);
            }
        }

    }

//    void ponCPU() {
//        dmgcpu = cpu;
//        oam = CPU.oam;
//    }
int di2,dj2,dl1,dj1;
boolean b1,b2;
byte byte1, byte2;
struct Paleta *paletagameboy;

    
    
    
    void notifyScanline(int i) {
      int i1,i2,j,j1,j2,k,k1,k2,l,l1,l2,word0,c; //di,dj,dk,dl;
//      do{
        if(i == 0) {
          i1 = getRgbEntry(&backgroundPalette,0);
          for(j = 0; j < 6400; j++) backBuffer[j] = i1;
            if(spritesEnabled)
                drawSprites(1);
        }
        if(!bgEnabled)
            return;
        j = registers[67]&0x7;
        k = registers[66]&0x7;
        if(((k + i)&0x7) == 4 || i == 0) {
            if(i >= 144 && i < 152)
                notifyScanline(i + 8);
            l = (registers[67]&0xff)>>3;
            i1 = (registers[66]&0xff)>>3;
            k1 = (i + k)>>3;
            c=((hiBgTileMapAddress)?0x1c00:0x1800)+(((k1 + i1)&0x1f)<<5);
            for(k2 = 0; k2 < 21; k2++) {
                if(bgWindowDataSelect) {
                    l1 = c +((k2 + l)&0x1f);
                    j1 = videoRam[l1]&0xff;
                    word0 = videoRam[l1 + 8192]&0xff;
                } else {
                    i2 = c + ((k2 + l)&0x1f);
                    j1 = 256 + videoRam[i2];
                    word0 = videoRam[i2 + 8192]&0xff;
                }
                l2 = 0;
                if(gbcFeatures) {
                    if((word0 & 8) != 0) {
                        j2 = 8192 + (j1 << 4);
                        j1 += 384;
                    } else {
                        j2 = j1 << 4;
                    }
                    if((word0 & 0x20) != 0) l2 |= 1;
                    if((word0 & 0x40) != 0) l2 |= 2;
                    l2 += (word0 & 7)<<2;
                } else {
                    j2 = j1 << 4;
                    l2 = 0;
                }
                dibuja((k2<<3) - j, (k1<<3) - k, l2, j2); //
//            if((di=(k2<<3) - j) >= 0 && (dj=(k1<<3) - k) >= 0 && di <= 151 && dj <= 135) {
//            	dk=l2; dl=j2;
//                if(gbcFeatures) {
//                    if(dk < 32) paletagameboy = gbcBackground+(dk >> 2);
//                    else       paletagameboy = gbcSprite+((dk >> 2) - 8);
//                } else
//                if((dk & 4) != 0) paletagameboy = &obj1Palette;
//                else
//                if((dk & 8) != 0) paletagameboy = &obj2Palette;
//                else  paletagameboy = &backgroundPalette;
//                b1=((dk&1)==0);  b2=((dk&2)==0);
//                for(di2 = 0, dl1=(dj<<7)+(dj<<5)+di; di2 < 8; di2++,dl1+=160) {
//                 	byte1=videoRam[dj1=((b2? di2 : (7 - di2))<<1)+dl];
//                 	byte2=videoRam[dj1+1];
//                 	for(dj2 = 0; dj2 < 8; dj2++) {
//                 	  backBuffer[dl1 + ((b1)?(7-dj2):dj2)] = paletagameboy->colours[
//                        paletagameboy->data[((byte1&1)+((byte2&1)<<1))]];
//                      byte1>>=1; byte2>>=1;
//                    }
//                }
//            }

          }
        }
        ++i;
  //    }while(--cnt>0);
    }

//    void clearFrameBuffer() {
//        int i = backgroundPalette.getRgbEntry(0);
//        for(int j = 0; j < 6400; j++) backBuffer[j] = i;
//    }

    void draw(int i, int j) {
        int c, i1,i2,j1,j2,k,k1,k2,l,l1,l2,word0;
        byte byte0;
        if(winEnabled) {
            if((registers[64] & 0x40) != 0)
                c = 0x1C00;
            else
                c = 0x1800;
            l = (registers[75]&0xff) - 7;
            word0 = registers[74]&0xff;
            i1 = getRgbEntry(&backgroundPalette,0);
            for(j1 = l; j1 < 101; j1++) {
                for(k1 = word0,k2=word0*160+j1; k1 < 80; k1++,k2+=160)
                    backBuffer[k2] = i1;
            }
            for(k2 = 0; k2 < 19 - (word0>>3); k2++) {
                for(l2 = 0; l2 < 21 - (l>>3); l2++) {
                    l1 = c + (k2<<5) + l2;
                    if(!bgWindowDataSelect)
                        k = 256 + videoRam[l1];
                    else
                        k = (videoRam[l1]&0xff);
                    j2 = k << 4;
                    if(gbcFeatures) {
                        byte0 = videoRam[l1 + 8192];
                        i2 = (byte0 & 7) << 2;
                        if((byte0 & 8) != 0) {
                            k += 384;
                            j2 += 8192;
                        }
                        if((byte0 & 0x20) != 0) i2 |= 1;
                        if((byte0 & 0x40) != 0) i2 |= 2;
                    } else { i2 = 0; }
                    dibuja(l + (l2<<3), word0 + (k2<<3), i2, j2);
                }

            }

        }
        drawSprites(0);
        if(gbcFeatures)
            drawSprites(1);
    }

byte xyz;
    
    void dibuja( int di,  int dj, int dk, int dl) {
extern void dibu(void *VRAM, void *BBUF, int COLOR,int DIJKL);//, int byte1,int byte2,int dj2);
      char colors[4];
   //   int col=0;
            if(di >= 0 && dj >= 0 && di <= 151 && dj <= 135) {
                if(gbcFeatures) {
                    if(dk < 32) paletagameboy = gbcBackground+(dk >> 2);
                    else       paletagameboy = gbcSprite+((dk >> 2) - 8);
                } else
                if((dk & 4) != 0) paletagameboy = &obj1Palette;
                else
                if((dk & 8) != 0) paletagameboy = &obj2Palette;
                else  paletagameboy = &backgroundPalette;
                for(int i=0;i<4;i++) //col=(col<<8)|(paletagameboy->colours[paletagameboy->data[i]]&0xff);
                  colors[i]=paletagameboy->colours[paletagameboy->data[i]];
   //dibu(videoRam, backBuffer, col, ((di&0xff)<<24)|((dj&0xff)<<16)|((dk&0xff)<<8)|(dl&0xff));              
                b1=((dk&1)==0);  b2=((dk&2)==0);
                for(di2 = 0, dl1=(dj<<7)+(dj<<5)+di; di2 < 8; di2++,dl1+=160) {
                 	byte1=videoRam[dj1=((b2? di2 : (7 - di2))<<1)+dl];
                 	byte2=videoRam[dj1+1];
                      	for(dj2 = 0; dj2 < 8; dj2++) {
//                          if((xyz=paletagameboy->data[((byte1&1)+((byte2&1)<<1))])!=splitcolor)  
//                   	    backBuffer[dl1 + ((b1)?(7-dj2):dj2)] = paletagameboy->colours[xyz];
//                          if((xyz=paletagameboy->data[((byte1&1)+((byte2&1)<<1))])!=splitcolor)  
                   	    backBuffer[dl1 + ((b1)?(7-dj2):dj2)] = colors[((byte1&1)+((byte2&1)<<1))];
                              //paletagameboy->colours[paletagameboy->data[((byte1&1)+((byte2&1)<<1))]];
                          //dibu(backBuffer, (void*)paletagameboy->colours, (void*)paletagameboy->data, dl1,dk);//, byte1,byte2,dj2);
                      byte1>>=1; byte2>>=1;
                    }
                }
            }
    }

    ///////////
    void CPUreset() { //CPU added!!!
            checkEnableGbc();
            setDoubleSpeedCpu(false);
            dispose();
            interruptsEnabled = false;
            ieDelay = -1;
            pc = 256;
            sp = 65534;
            f = 176;
            gbcRamBank = 1;
            instrCount = 0;
            if(gbcFeatures)
                a = 17;
            else
                a = 1;
            setBC(19);
            setDE(216);
            setHL(333);

            reset(damegbcBack(), damegbcSprite());
        }
    

    
    void CPUstart(){
            //loadrom();
            checkEnableGbc();
//            ponCPU();
            listo = true;
            //videoRam = ChipGrafico.videoRam;
    }

    void terminateProcess() {
        terminate = true;
    }

//    void repaint(){ 
//      REDRAW(); 
//    } 
    
   boolean loadrom(char *fname) {
      if(!(rom=(byte*)loadfile(fname))) return false;
      cartType = rom[327];
      return true;
   }

   void clsvideo(){
     for(int j = 0; j < 16384; j++)
      videoRam[j] = 0;
   }

   void cls(){
     memset(screen,0xff,screensize);
   }

///////////////////////////////////////////////////
//////////////////////////////////////////////////

typedef struct
{
  GUI gui;
  WSHDR *ws1;
  WSHDR *ws2;
  int i1;
}MAIN_GUI;

typedef struct
{
  CSM_RAM csm;
  int gui_id;
}MAIN_CSM;

const int minus11=-11;
//const unsigned int INK=0;
//const unsigned int PAPER=1;
//volatile int xx=0, yy=0;

//const char bmp[12]={0xFC,0x86,0xB3,0xA9,0xB1,0xA9,0x81,0xFF,0,0,0,0};
const IMGHDR img = {(unsigned)132,(unsigned)176,5,0,(char*)screen};

//void timer_proc(void){
//  if(!mode){
//    REDRAW();
//  }
//  GBS_StartTimerProc(&timer,fps,timer_proc);
//}

//void start(){
//  mode=0;
//  SUBPROC((void *)execute);
//}
//================================
//  
//================================

void DrwImg(IMGHDR *img, int x, int y, int *pen, int *brush)
{
  RECT rc;
  DRWOBJ drwobj;
  StoreXYWHtoRECT(&rc,x,y,img->w,img->h);
  SetPropTo_Obj5(&drwobj,&rc,0,img);
  SetColor(&drwobj,pen,brush);
  DrawObject(&drwobj);
}

//inline int r3216(int rgb){
//  int r=rgb>>19;
//  int g=(rgb>>10)&0x3f;
//  int b=(rgb>>3)&0x1f;
//  return (r<<11)|(g<<5)|b;
//}


//inline void DrawScreen(void)
//{
//  int i,j;
//  unsigned char *s=screen;
//  unsigned char *ss;
//    for(j=0;j<160;j++){
//      ss=backBuffer+160*j;
//      for(i=0;i<132;i++)
//        *s++=*ss++;//r3216(*ss++);
//    }
//   DrwImg((IMGHDR *)&img,0,0,GetPaletteAdrByColorIndex(0),GetPaletteAdrByColorIndex(1));
//}

void DrawScreen(void)
{
  extern void redraw(void *TO, void *FROM, int f);
//  int i,j,k;
//  unsigned char *s=screen, *b=backBuffer;


//  switch(rotate){
//  case 1:
//    s+=131;
//    for(j=k=0;j<160;j++){
//      for(i=0;i<160;i++,s+=132){
//        *s=*b++;
//      }
//      s-=132*160+1;
//      if(++k==5){ k=0; ++j; b+=160;}
//    } break;
//  case 2:
//    
//    break;
//  case 0:
//  default:
//    for(j=k=0;j<160;j++){
//      for(i=0;i<26;i++){
//        *s++=*b++;
//        *s++=*b++;
//        *s++=*b++;
//        *s++=*b++;
//        *s++=*b++;
//        ++b;
//      }
//      *s++=*b++;
//      *s++=*b++;
//      b+=2;
//      if(fsmall && ++k==5){ k=0; ++j; b+=160;}
//    } break;
//   }
   redraw(screen,backBuffer,fsmall);
   if(mode) drawhelp();
   DrwImg((IMGHDR *)&img,0,0,GetPaletteAdrByColorIndex(0),GetPaletteAdrByColorIndex(1));
}

//  
void method0(MAIN_GUI *data){
    DrawScreen();
}

void method1(MAIN_GUI *data, void *(*malloc_adr)(int)){
  //   mode=0;
   SUBPROC((void *)execute);
//   DrawScreen();
   //start();
//     SUBPROC((void *)run);
   //GBS_StartTimerProc(&timer,262/20,timer_proc);
    data->gui.state=1;
}

void method2(MAIN_GUI *data, void (*mfree_adr)(void *)){
  data->gui.state=0;
}

void method3(MAIN_GUI *data, void *(*malloc_adr)(int), void (*mfree_adr)(void *)){
  data->gui.state=2;
}

void method4(MAIN_GUI *data, void (*mfree_adr)(void *)){
  if (data->gui.state!=2) return;
  data->gui.state=1;
}

void method7(MAIN_GUI *data, void (*mfree_adr)(void *)){
//  mfree_adr(data);
}

int method8(void){return(0);} //  -
 
int method9(void){return(0);} //  -

//------------------------------------------------------------------------------
// .  -  
//------------------------------------------------------------------------------
//void key(int keyCode, int press){
//  keyCode=param[100+alternate+keyCode-'0'];
//  if(press) keylines[(keyCode>>4)&0x7]&=~(1<<(keyCode&0x7));
//  else      keylines[(keyCode>>4)&0x7]|=(1<<(keyCode&0x7));
//}
//
//void getkkk(){ //count redkey
//  if(!(redkey-='0'))  redkey=10;
//  --count; --count;
//  if(--redkey<6) param[100+alternate+rrkey-'0'] = param[redkey*4+(count%4)] ;
//  else param[100+alternate+rrkey-'0'] = param[24+(redkey-6)*5+(count%5)] ;
//}

inline void start(){
  mode=0; 
}

int method5(MAIN_GUI *data, GUI_MSG *msg)
{
  unsigned char keycode=msg->gbsmsg->submess;
  if (msg->gbsmsg->msg==KEY_UP){ //  
    keyGB(keycode,false);
    return 0;
  }
  if ((msg->gbsmsg->msg==KEY_DOWN)||(msg->gbsmsg->msg==LONG_PRESS)){ // .   
    if(keycode==RED_BUTTON){ terminate=true;  return(1); }//  GeneralFunc  . GUI ->  GUI
    switch(mode){
    case 99: // menu
      switch(keycode){
      case '1': mode=1; break;  //Load
      case '2': mode=2; break;  //Save
      case '3': mode=3; break; //fps
      case '4': mode=4; break; //SprCol
      case '7': cls();
        if(++rotate>2) rotate=0;
        start(); break;
      case '8': 
        fsmall=!fsmall; 
        start(); break;
      case '0': return(1);
      default: start(); break;
    }break;
    case 1: //Load
    case 2: //Save
      start(); break;  
    case 3: //fps
      if(keycode>='0' && keycode<='4')
        frameskip=keycode-'0';
      start(); break;
    case 4: //fps
      if(keycode>='0' && keycode<='4')
        splitcolor=keycode-'0';
      start(); break;
    case 0: // in game
      if(keycode==RIGHT_SOFT){ mode=99; DrawScreen();}
      else keyGB(keycode,true);
      break;
    default: start(); break;
    }
  DrawScreen();
  }
  return 0;
}

const void * const gui_methods[11]={
  (void *)method0,	//Redraw
  (void *)method1,	//Create
  (void *)method2,	//Close
  (void *)method3,	//Focus
  (void *)method4,	//Unfocus
  (void *)method5,	//OnKey
  0,
  (void *)method7,	//Destroy
  (void *)method8,
  (void *)method9,
  0
};

const RECT Canvas={0,0,131,175};

void maincsm_oncreate(CSM_RAM *data)
{
  MAIN_GUI *main_gui=malloc(sizeof(MAIN_GUI));
  MAIN_CSM*csm=(MAIN_CSM*)data;
  zeromem(main_gui,sizeof(MAIN_GUI));

//  ustk=malloc(STKSZ); //  
 // info_ws=AllocWS(512);

  main_gui->gui.canvas=(void *)(&Canvas);
  main_gui->gui.flag30=2;
  main_gui->gui.methods=(void *)gui_methods;
  main_gui->gui.item_ll.data_mfree=(void (*)(void *))mfree_adr();
  csm->csm.state=0;
  csm->csm.unk1=0;
  csm->gui_id=CreateGUI(main_gui);
  UpdateCSMname();
}


void Killer(void){
  extern void *ELF_BEGIN;
  extern void kill_data(void *p, void (*func_p)(void *));
  terminate=true;
  
  if(rom) mfree(rom);
  if(saveram) mfree(saveram);
  kill_data(&ELF_BEGIN,(void (*)(void *))mfree_adr());
//  ((void (*)(void *))(mfree_adr()))(&ELF_BEGIN);
}

void maincsm_onclose(CSM_RAM *csm)
{
  terminate=true;
  SUBPROC((void *)Killer);
}


int maincsm_onmessage(CSM_RAM *data, GBS_MSG *msg){  
  MAIN_CSM *csm=(MAIN_CSM*)data;
  if ((msg->msg==MSG_GUI_DESTROYED)&&((int)msg->data0==csm->gui_id))
     csm->csm.state=-3; 
  return(1);
}

unsigned short maincsm_name_body[140];

const struct
{
  CSM_DESC maincsm;
  WSHDR maincsm_name;
}MAINCSM =
{
  {
  maincsm_onmessage,
  maincsm_oncreate,
#ifdef NEWSGOLD  
  0,
  0,
  0,
  0,
#endif  
  maincsm_onclose,
  sizeof(MAIN_CSM),
  1,
  &minus11
  },
  {
    maincsm_name_body,
    NAMECSM_MAGIC1,
    NAMECSM_MAGIC2,
    0x0,
    139
  }
};
/*
boolean loadini(){
  int f;
  char *ptr;
  *(ptr=file)='i'; *++ptr='n'; *++ptr='i'; *++ptr=0;
  if((f=fopen(filename,A_ReadOnly+A_BIN,0,&err))==-1) return false;
  if(fread(f, param, paramlength, &err)!=paramlength){ fclose(f,&err); return false;}
  fclose(f,&err);
  rotate=param[100];
  speed=param[101];
  alternate=param[102];
  fullscreen=param[103];
  return true;
}

boolean saveini(){
  int f;
  char *ptr;
  *(ptr=file)='i'; *++ptr='n'; *++ptr='i'; *++ptr=0;
  if((f=fopen(filename,A_ReadWrite+A_BIN+A_Create,P_READ+P_WRITE,&err))==-1) return false;
  param[100]=rotate;
  param[101]=speed;
  param[102]=alternate;
  param[103]=fullscreen;
  fwrite(f, param, paramlength, &err);
  fclose(f,&err);
  return true;
}
*/

int main(char *exename, char *fname){
   char dummy[sizeof(MAIN_CSM)];
   do{
    if(!fname) break;
    strcpy(filename,exename);
    file=filename+strlen(filename);
    while(file>filename && *--file!='.');
    ++file; 
    //loadini();
    if(!loadrom(fname)) break;
    ChipGrafico();
    clsvideo();
    cls();
    resetRom();
    CPUreset();
    CreateCSM(&MAINCSM.maincsm,dummy,0);
    return 0; 
  }while(0);
  SUBPROC((void *)Killer);
  return 0;
}

inline void UpdateCSMname(){
//WSHDR *ws=AllocWS(256);
wsprintf((WSHDR *)(&MAINCSM.maincsm_name),Title);
//FreeWS(ws);
}

char *loadfile(char *filename){ //  , -
  int f; unsigned int err;  char *buf=0;
  if((f=fopen(filename,A_ReadOnly+A_BIN,P_READ,&err))!=-1){
    if(loadfilesize=lseek(f,0,2,&err,&err)){
      buf=(char*)malloc(loadfilesize);
      lseek(f,0,0,&err,&err);
      if(fread32(f,buf,loadfilesize,&err)!=loadfilesize){ mfree(buf); buf=0;}
    } fclose(f,&err);
#ifdef UNPACK
//   . 7z  rar .
//  extern char *un7z(char *buf);
//  extern char *unrar(char *buf);
    extern char *unzip(char *buf);
    if(buf && loadfilesize>4){
      if(*(int*)buf==0x4034b50) buf=unzip(buf); //unzip
    }
#endif      
  } return buf;
}
